Program Zita_Organizer(Output);
{$A+,B+,D+,E+,F-,I+,L+,N+,O-,R+,S+,V+}
{$IFNDEF h} {$M 16384,32768,32768} {$ENDIF}
Uses Crt,Dos;
Type        Real = Extended;
Extension = String[4];
Directories = String[13];
MainTitle = String[125];
Data = Record
actual:Integer; show:Pointer
End;
Data2 = Record
lo,hi:Integer; nop:Pointer
End;
DataExp = Record
actual:Integer; c:Char; w,r,t:Real;
show,nop:Pointer
End;
MeasChar = Record
c1,c2:Integer; w,r:Real; show:Pointer
End;
Parameter = Record
value:Real; fit:Char; next:Pointer
End;
Model = Record
serial,fnum:Integer; next,parameter:Pointer
End;
Names = Record
curve:String[8]; next:Pointer
End;
OtherTask = Record
tname:String[12]; next:Pointer
End;
Const up:Boolean = False;
p = 23;
keyword:Array[1..p] Of String[25] =
('BASENAME',               'SIGNIFICANT DIGITS',
'NUMBER OF CHARACTERS',   'PLACE OF THE RESULT FILES',
'INTEGRATION METHOD',     'RELATIVE ERROR',
'INITIAL STEP',           'LINES MUST BE SKIPPED',
'DIFFERENTIATION METHOD', 'PERCENT',
'EXPERIMENTAL CURVES',    'CONTENT OF THE RESULT',
'INITIAL CONCENTRATION',  'CHARACTERISTIC',
'MODEL',                  'ABSOLUTE, RELATIVE',
'OTHER TASK',             'INNER POINT',
'ACCOMPLISHED RANGE',     'FIGURES',
'.COL',                   'OUTPUT FILES',
'SPEED OPTIMALIZATION');
Var                storeplace,method,b,dosexit:Byte;
eztk,cols,figures,digits,i1,counter:Integer;
maxi,dr1,accr,med,med1,lineweight,
initlines,i,j,k,l,iter:Word;
i2,time:LongInt;
t,ht0,ht,hs,error,step0,percent,hr:Real;
diffmeth,absrel,c:Char;
iffit:Boolean;
dv:String[2];
sopt,basename:String[4];
hb:String[8];
h,taskfile,pr2,pr3,pr4,pr5,pr6,pr7,pr8,pr9:String[12];
line2,line,com,lin:String[127];
inp,out,tem:Text;
zitabase,zitatemp,zitasimu,zitard:PathStr;
di:SearchRec;
re0,re1,re2,oc0,oc1,oc2,ic0,ic1,ic2:^Data;
da1,da2:^Data2;
ex0,ex1,ex2:^DataExp;
mc0,mc1,mc2:^MeasChar;
pa1,pa2:^Parameter;
md0,md1,md2:^Model;
cu0,cu1,cu2:^Names;
ts0,ts1,ts2:^OtherTask;
title:^MainTitle;
{$F+}
Function HeapFunc(Size:Word):Integer; {$F-}
Begin
If Size > 0 Then Begin
Writeln(Output,
Size,' byte(s) could not be allocated in the heap.');
Writeln(Output,'Read the use of NEWEXE.BAT in the Manual!');Halt
End;
End;
Procedure Errors(line:String);
Begin
If taskfile <> ''
Then Writeln(Output,taskfile+' is the actual file.');
Writeln(Output,line);Halt
End;
Procedure BigHeap;
Begin
dosexit:=DosExitCode;
If DosError = 8 Then Begin
Writeln(Output,'There is not enough memory!',Chr(13),Chr(10),
'The size of RAM disk should be decreased if it is placed ',
'in the base ',Chr(13),Chr(10),'640 KByte memory or do not ',
'use the TASK.EXE!');Halt
End;
If DosError = 2 Then Begin
Writeln(Output,'An *.exe file is missing (probably Zita.exe)!');
Halt
End 
End;
Procedure GetExp;
Var i,j,k:Integer;
Procedure Mess; Begin
Errors('There is an invalid number among the experimental curves!')
End;
Begin
line:='';Read(inp,c);
While c <= ' ' Do Read(inp,c);
While c > ' ' Do Begin
line:=line+Upcase(c);Read(inp,c)
End;
j:=1;
While (line[j] In ['-','0'..'9']) And (Length(line) > j) Do Inc(j);
If Not (line[j] In ['0'..'9']) Then j:=j-1;
c:=' ';Val(Copy(line,1,j),i1,i);
If i <> 0 Then Mess;
k:=Pos('W',line);
If k > 0 Then Begin
Inc(k);j:=k;c:='W';
While (line[j] In ['+','-','0'..'9','.','e','E'])
And (Length(line) > j) Do Inc(j);
If Not (line[j] In ['0'..'9','.']) Then j:=j-1;
Val(Copy(line,k,j+1-k),hr,i);
If i <> 0 Then Mess
End;
k:=Pos('R',line);
If k > 0 Then Begin
Inc(k);j:=k;If c = 'W' Then c:='Z' Else c:='R';
While (line[j] In ['+','-','0'..'9','.','e','E'])
And (Length(line) > j) Do Inc(j);
If Not (line[j] In ['0'..'9','.']) Then j:=j-1;
Val(Copy(line,k,j+1-k),ht,i);
If i <> 0 Then Mess
End;
k:=Pos('P',line);lin:='';
If k > 0 Then Begin
j:=Pos('[',line);i:=Pos(']',line);
If ((j-1) = k) And (i > j) Then lin:=Copy(line,j,i-j+1)
End;
k:=Pos('T',line);
If k > 0 Then Begin
Inc(k);j:=k;
While (line[j] In ['+','-','0'..'9','.','e','E'])
And (Length(line) > j) Do Inc(j);
If Not (line[j] In ['0'..'9','.']) Then j:=j-1;
Val(Copy(line,k,j+1-k),ht0,i);
If i <> 0 Then Mess
End 
Else ht0:=0.0
End;
Procedure FF(f:Directories);
Begin
FindFirst(zitatemp+'\'+f,AnyFile,di)
End;
Procedure Residuals(h:Char);
Begin
SwapVectors;
Exec(zitabase+'\Jc.exe',basename+' '+h+' 0');
SwapVectors;BigHeap;
If dosexit = 0 Then Begin
Assign(inp,zitatemp+'\J.col');Reset(inp);
Readln(inp,line);
While Pos('Fitting',line) = 0 Do Readln(inp,line);
k:=Pos('=',line)+1;
While line[k] = ' ' Do Inc(k);Delete(line,1,k-1);
k:=2;
While line[k] <> ' ' Do Inc(k);
Val(Copy(line,1,k-1),i2,i1);
k:=Pos('=',line);If line[1] = ' ' Then Inc(k);
Delete(line,1,k);Val(line,t,k);
If (k = 0) And (i1 = 0) Then
Write(out,'  ',t*Sqrt(i2/(i2-md1^.fnum)),' in the case of ');
Case h Of
'a':Write(out,'ABSOLUTE');
'r':Write(out,'RELATIVE');
'o':Write(out,'ORTHOGONAL')
End;
Writeln(out,' residuals.');
Close(inp)
End 
End;
Procedure Initialization;
Var i:Word;
di:SearchRec;
Procedure Environments(value,base:Directories;Var env:PathStr);
Begin
env:=GetEnv(value);
If env = '' Then env:=base;
FindFirst(env,Directory,di);i:=DosError;
If i <> 0 Then FindFirst(env+'\*.*',Directory,di);
If (i <> 0) And (Not (DosError In [0,18])) Then
Errors('The DOS environment variable "'+value+
'" has a wrong value!')
End;
Procedure Help;
Begin
While (line[1] <= ' ') And (Length(line) > 0) Do Delete(line,1,1);
i:=1;
While (line[i] > ' ') And (Length(line) >= i) Do Inc(i)
End;
Begin
Environments('ZitaBASE','.',zitabase);
Environments('ZitaTEMP','.',zitatemp);
Environments('ZitaSIMU','.\Simu',zitasimu);
Environments('ZitaRD','.\Simu',zitard);
taskfile:='';
If ParamCount > 0 Then Begin
taskfile:=ParamStr(1);
For i:=1 To Length(taskfile) Do taskfile[i]:=UpCase(taskfile[i]);
If Pos('.',taskfile) = 0 Then taskfile:=taskfile+'.TSK'
End 
Else Errors('The filename of actual task (1st DOS parameter) '+
'is missing!');
FindFirst(taskfile,AnyFile,di);
If DosError <> 0
Then Errors('The '+taskfile+' file does not exist!');
time:=di.Time;
Assign(inp,taskfile);Reset(inp);
pr2:=ParamStr(2);pr3:=ParamStr(3);pr4:=ParamStr(4);pr5:=ParamStr(5);
pr6:=ParamStr(6);pr7:=ParamStr(7);pr8:=ParamStr(8);pr9:=ParamStr(9);
basename:='Base';digits:=6;lineweight:=80;method:=21;figures:=0;
error:=1.0E-08;step0:=1.0E-10;
initlines:=1;med:=0;med1:=0;accr:=0;cols:=0;
dv:='';sopt:='';
If pr9 = '' Then Begin
storeplace:=0; diffmeth:='+';percent:=1.0;  absrel:='R'
End 
Else Begin
Val(pr8,storeplace,j);diffmeth:=pr7[1];Val(pr6,percent,j);
absrel:=pr5[1]
End;
New(ex0);ex0^.show:=Nil;ex0^.show:=Nil;
New(oc0);oc0^.show:=Nil;
New(ic0);ic0^.show:=Nil;
New(re0);re0^.show:=Nil;
New(mc0);mc0^.show:=Nil;mc0^.c1:=0;
New(md0);md0^.next:=Nil;md0^.serial:=0;md0^.fnum:=0;md1:=md0;
New(ts0);ts0^.next:=Nil;ts0^.tname:='';
FF('Odes.pas');
If DosError <> 0
Then
Errors('ODES.PAS file cannot be found in '+zitatemp+' library.')
Else Begin
Assign(out,zitatemp+'\Odes.pas');Reset(out);
lin:='   ';Read(out,lin[2],lin[3]);
Repeat
lin[1]:=lin[2];lin[2]:=lin[3];Read(out,lin[3]);
i:=Pos('rks',Copy(lin,1,3))
Until SeekEof(out) Or (i <> 0);
If i = 0 Then
Errors('The RKS variable cannot be found in ODES.PAS!');
Read(out,c);
While c <> '(' Do Read(out,c);
While c <> '0' Do Read(out,c);
While c = '0' Do Read(out,c);
lin:=c;
re1:=re0;
While Pos(')',lin) = 0 Do Begin
lin:='';
While (Not (c In ['+','-','0'..'9'])) And
(Pos(')',lin) = 0) Do Begin
lin:=lin+c;Read(out,c)
End;
If Pos(')',lin) = 0 Then Begin
lin:='';
While c In ['+','-','0'..'9'] Do Begin
lin:=lin+c;Read(out,c)
End;
Val(lin,re1^.actual,i);
New(re2);re1^.show:=re2;re1:=re2
End 
End;
re1^.show:=Nil;
Reset(out);
lin:='  ';Read(out,lin[2]);
Repeat
lin[1]:=lin[2];Read(out,lin[2]);
i:=Pos('ez',Copy(lin,1,2))
Until SeekEof(out) Or (i <> 0);
If i = 0 Then
Errors('The EZ variable cannot be found in ODES.PAS!');
Read(out,c);
While c <> '=' Do Read(out,c);
While Not (c In ['+','0'..'9']) Do Read(out,c);
lin:=c;
Read(out,c);
While c In ['0'..'9'] Do Begin
lin:=lin+c;Read(out,c)
End;
Val(lin,eztk,i);If i <> 0 Then eztk:=0;
Reset(out);
lin:='  ';Read(out,lin[2]);
Repeat
lin[1]:=lin[2];Read(out,lin[2]);
i:=Pos('tk',Copy(lin,1,2))
Until SeekEof(out) Or (i <> 0);
If i = 0 Then
Errors('The TK variable cannot be found in ODES.PAS!');
Read(out,c);
While c <> '=' Do Read(out,c);
While Not (c In ['+','0'..'9']) Do Read(out,c);
lin:=c;
Read(out,c);
While c In ['0'..'9'] Do Begin
lin:=lin+c;Read(out,c)
End;
Val(lin,j,i);If i <> 0 Then j:=0;
eztk:=eztk+j;
Close(out)
End;
Repeat
Repeat Readln(inp,line) Until (line[1] = '+') Or SeekEof(inp);
j:=0;
If SeekEof(inp) Then line:=''
Else Begin
For i:=1 To Length(line) Do line[i]:=UpCase(line[i]);
i:=1;
While (i <= p) And (j = 0) Do
If Pos(keyword[i],line) <> 0 Then j:=i Else Inc(i);
If j = 0 Then Begin
Close(inp);Writeln(Output,line);
Errors('The line above starting with "+" does not contain '+
'any keyword!')
End;
Case j Of
1:Readln(inp,basename);
2:Readln(inp,digits);
3:Readln(inp,lineweight);
4:If pr9 = '' Then Readln(inp,storeplace) Else Readln(inp);
5:Readln(inp,method);
6:Readln(inp,error);
7:Readln(inp,step0);
8:Readln(inp,initlines);
9:If pr9 = '' Then Readln(inp,diffmeth) Else Readln(inp);
10:If pr9 = '' Then Readln(inp,percent) Else Readln(inp);
11:Begin
GetExp;
While i1 >= 0 Do Begin
ex1:=ex0;
While (ex1^.show <> Nil) And (ex1^.actual < i1) Do
ex1:=ex1^.show;
If (ex1^.show = Nil) Or
((ex1^.show <> Nil) And (ex1^.actual <> i1))
Then Begin
New(ex2);
If ex1^.show = Nil
Then ex2^.show:=Nil
Else If ex1^.actual <> i1 Then ex2^:=ex1^;
ex1^.actual:=i1;ex1^.t:=ht0;
ex1^.c:=c;
If c In ['W','Z'] Then ex1^.w:=hr;
If c In ['R','Z'] Then ex1^.r:=ht;
If lin = ''
Then ex1^.nop:=Nil
Else Begin
New(da1);ex1^.nop:=da1;da1^.nop:=Nil;
Delete(lin,1,1);Delete(lin,Length(lin),1);
Repeat
j:=Pos(',',lin);
If j > 0
Then Begin
com:=Copy(lin,1,j-1);Delete(lin,1,j)
End 
Else Begin
com:=lin;lin:=''
End;
Val(com,j,l);
If l = 0
Then Begin
da1^.lo:=j+eztk;da1^.hi:=j+eztk;
New(da2);da1^.nop:=da2;da2^.nop:=Nil;
da1:=da2
End 
Else Begin
k:=Pos('..',com);
If k > 0 Then Begin
Val(Copy(com,1,k-1),j,l);
If l = 0 Then Begin
Delete(com,1,k+1);Val(com,k,l);
If l = 0 Then
da1^.lo:=j+eztk;da1^.hi:=k+eztk;
New(da2);da1^.nop:=da2;da2^.nop:=Nil;
da1:=da2
End 
End 
End 
Until lin = ''
End;
ex1^.show:=ex2
End;
GetExp
End 
End;
12:Begin
Read(inp,oc0^.actual);oc1:=oc0;
For i:=1 To oc0^.actual Do Begin
New(oc2);oc1^.show:=oc2;Read(inp,oc2^.actual);oc1:=oc2
End;
oc1^.show:=Nil
End;
13:Begin
Read(inp,ic0^.actual);ic1:=ic0;
For i:=1 To ic0^.actual Do Begin
New(ic2);ic1^.show:=ic2;Read(inp,ic2^.actual);ic1:=ic2
End;
ic1^.show:=Nil;
FF('Odes.pas');
Assign(out,zitatemp+'\Odes.pas');Reset(out);
Repeat
Readln(out,lin);
For i:=1 To Length(lin) Do lin[i]:=UpCase(lin[i]);
i:=Pos('CS=',lin);k:=Pos('CS =',lin)
Until SeekEof(out) Or (i <> 0) Or (k <> 0);
If (i = 0) And (k = 0) Then
Errors('The value of CS cannot be found in ODES.PAS!')
Else Begin
If i < k Then i:=k;
While Not (lin[i] In ['0'..'9']) Do Inc(i);k:=i;
While lin[k] In ['0'..'9'] Do Inc(k);
lin:=Copy(lin,i,k-i);Val(lin,k,i)
End;
Close(out);
If k In [1..3] Then Begin
New(ic2);ic1^.show:=ic2;ic1:=ic2;Read(inp,ic1^.actual);
For i:=1 To ic1^.actual Do Begin
New(ic2);ic1^.show:=ic2;Read(inp,ic2^.actual);
ic1:=ic2
End;
ic1^.show:=Nil
End 
End;
14:Begin
Read(inp,i1);mc1:=mc0;
While i1 > 0 Do Begin
Inc(mc0^.c1);
New(mc2);mc2^.c1:=i1;Read(inp,mc2^.c2);
If SeekEoln(inp)
Then mc2^.w:=1.0 Else Read(inp,mc2^.w);
If SeekEoln(inp)
Then mc2^.r:=1.0 Else Read(inp,mc2^.r);
mc1^.show:=mc2;mc1:=mc2;Read(inp,i1)
End 
End;
15:Begin
If md1^.serial = 0 Then md1^.serial:=1
Else Begin
New(md2);md1^.next:=md2;md2^.fnum:=0;
md2^.serial:=md1^.serial+1;md2^.next:=Nil;md1:=md2
End;
New(pa1);md1^.parameter:=pa1;
pa1^.fit:=' ';l:=1;
Repeat
line:='';
Repeat
Readln(inp,line)
Until (line <> '') Or SeekEof(inp);
If line <> '' Then Begin
Help;Val(Copy(line,1,i-1),pa1^.value,k);
If k = 0 Then Begin
Delete(line,1,i-1);Help;
New(pa2);pa1^.next:=pa2;
re1:=re0;
While re1^.show <> Nil Do Begin
If (re1^.actual = l) And (line[1] = '*') Then
line[1]:=' ';
re1:=re1^.show
End;
Inc(l);
If line[1] = '*' Then Begin
Inc(md1^.fnum);
pa1^.fit:='*';pa1:=pa2;pa1^.fit:=' '
End 
Else Begin
Val(Copy(line,1,i-1),hr,j);
If j = 0 Then Begin
pa1^.fit:='1';pa1:=pa2;
pa1^.value:=hr;pa1^.fit:='2';
For c:='3' To '5' Do Begin
New(pa2);pa1^.next:=pa2;pa1:=pa2;
Read(inp,pa1^.value);pa1^.fit:=c
End;
New(ic1);pa1^.next:=ic1;
Read(inp,ic1^.actual);
If SeekEoln(inp) Then Begin
Readln(inp);ic1^.show:=Nil
End 
Else Begin
New(title);ic1^.show:=title;
Readln(inp,title^)
End 
End 
Else Begin
pa1^.fit:=' ';pa1:=pa2;pa1^.fit:=' '
End 
End 
End 
Else Errors('There is a string in a model '+
'which cannot be interpreted as a number!')
End 
Until SeekEof(inp) Or (k <> 0) Or (pa1^.fit = '5');
If pr9 <> '' Then Begin
md0^.serial:=0;md0^.next:=Nil;md1:=md0
End 
End;
16:If pr9 = '' Then Readln(inp,absrel) Else Readln(inp);
17:Begin
Readln(inp,ts0^.tname);ts1:=ts0;
While Copy(ts1^.tname,1,2) <> '-1' Do Begin
For i:=1 To Length(ts1^.tname) Do
ts1^.tname[i]:=Upcase(ts1^.tname[i]);
If Pos('.',ts1^.tname) = 0
Then ts1^.tname:=ts1^.tname+'.TSK';
New(ts2);ts2^.next:=Nil;ts1^.next:=ts2;ts1:=ts2;
Readln(inp,ts1^.tname)
End;
If pr9 <> '' Then Begin
ts0^.tname:='';ts0^.next:=Nil
End 
End;
18:Begin
Read(inp,med);
If SeekEoln(inp) Then med1:=med Else Readln(inp,med1)
End;
19:Readln(inp,accr);
20:If pr9 = '' Then Readln(inp,figures) Else Readln(inp);
21:Readln(inp,cols);
22:Begin
Readln(inp,dv);
If Length(dv) > 0 Then dv[1]:=Upcase(dv[1]);
If Length(dv) > 1 Then dv[2]:=Upcase(dv[2])
End;
23:Begin
Readln(inp,sopt);
For i:=1 To Length(sopt) Do sopt[i]:=Upcase(sopt[i]);
If sopt = 'YES' Then sopt:=' OPT' Else sopt:=''
End 
End;
If SeekEoln(inp) Then Readln(inp)
End;
Until SeekEof(inp);
If (ex0^.show = Nil) And (ts0^.next = Nil) Then
Errors('There is not any experimental curves!');
If oc0^.show = Nil
Then Errors('The output results are not defined!');
If ic0^.show = Nil
Then Errors('The initial concentrations are not defined!');
If mc0^.c1 = 0 Then Errors('There is not any characteristic');
If (md0^.serial = 0) And (pr9 = '')
Then Errors('There is not any model!');
Close(inp)
End;
Procedure ActDateTime;
Begin
GetDate(i,j,k,l);Write(out,'Date: ',j,'m',k,'d',i,'y.  ');
GetTime(i,j,k,l);Write(out,'Time: ',i,':',j,'. ')
End;
Procedure DatJcd;
Begin
If pr9 = '' Then Begin
Assign(out,zitatemp+'\'+basename+'.dat');Rewrite(out);
Writeln(out,
'This file has been created based on the following file(s):');
Write(out,taskfile);
ts1:=ts0;
While ts1^.next <> Nil Do Begin
Write(out,', ',ts1^.tname);ts2:=ts1^.next;ts1:=ts2
End;
Writeln(out,'.');
ActDateTime;Writeln(out)
End 
Else Begin
Assign(out,zitatemp+'\'+pr9+'.dat');Append(out)
End;
If ex0^.show <> Nil Then Begin
Writeln(out,digits,' ',lineweight,' ',storeplace);
Write(out,method,Abs(error):12);
If step0 < 0.0 Then Write(out,' ');
Writeln(out,step0:12);
oc1:=oc0;
While oc1^.show <> Nil Do Begin
Writeln(out,oc1^.actual);oc1:=oc1^.show
End;
Writeln(out,oc1^.actual)
End;
ex1:=ex0;
While ex1^.show <> Nil Do Begin
Write(out,'0');
If ex1^.nop = Nil
Then Writeln(out)
Else Begin
Write(out,' [');
da1:=ex1^.nop;
While da1^.nop <> Nil Do Begin
Write(out,da1^.lo);
If da1^.lo < da1^.hi Then Write(out,'..',da1^.hi);
da1:=da1^.nop;
If da1^.nop <> Nil Then Write(out,',')
End;
Writeln(out,']')
End;
Str(ex1^.actual,hb);hb:='0000'+hb;Delete(hb,1,Length(hb)-4);
Write(out,'2 ',basename,hb,'.Exp ');
ic1:=ic0;
For i:=0 To ic0^.actual Do Begin
Write(out,ic1^.actual,' ');ic1:=ic1^.show
End;
Writeln(out);
If ic1 <> Nil Then Begin
While ic1^.show <> Nil Do Begin
Write(out,ic1^.actual,' ');ic1:=ic1^.show
End;
Writeln(out,ic1^.actual)
End;
If accr = 0 Then
If (med = 0) And (med1 = 0)
Then Begin
If ex1^.t < 0.0 Then Write(out,'3 ') Else Write(out,'3');
Writeln(out,ex1^.t)
End 
Else Begin
Write(out,'6 ',med,' ',med1);
If ex1^.t < 0.0 Then Write(out,' ');
Writeln(out,ex1^.t)
End 
Else Begin
Write(out,'9 ',med,' ',med1);
If ex1^.t < 0.0 Then Write(out,' ');
Writeln(out,ex1^.t)
End;
Writeln(out,'P ',basename,hb,'.Tmp');
If Pos('V',dv) = 0 Then Writeln(out,'0') Else Writeln(out,'P v');
If Pos('D',dv) = 0 Then Writeln(out,'0') Else Writeln(out,'P d');
ex1:=ex1^.show;
If ex1^.show = Nil Then
If pr9 = '' Then
If ts0^.next = Nil Then Writeln(out,'N') Else Writeln(out,'F')
Else  Writeln(out,pr4)
Else Writeln(out,'Y')
End;
Close(out);
If pr9 = '' Then Begin
Assign(out,zitatemp+'\'+basename+'.jcd');Rewrite(out);
Writeln(out,storeplace,' ',storeplace);
End 
Else Begin
Assign(out,zitatemp+'\'+pr9+'.jcd');Append(out)
End;
mc1:=mc0;
For j:=1 To mc0^.c1 Do Begin
mc1:=mc1^.show;i:=mc1^.c1;k:=mc1^.c2;
ex1:=ex0;
While ex1^.show <> Nil Do Begin
If ex1^.c In ['W','Z'] Then hs:=ex1^.w Else hs:=mc1^.w;
Str(ex1^.actual,hb);hb:='0000'+hb;Delete(hb,1,Length(hb)-4);
Write(out,basename,hb,'.Exp ',i,' ');
If ex1^.nop = Nil
Then Write(out,initlines)
Else Begin
da1:=ex1^.nop;
Write(out,-initlines,' [');
While da1^.nop <> Nil Do Begin
Write(out,da1^.lo);
If da1^.lo < da1^.hi Then Write(out,'..',da1^.hi);
da1:=da1^.nop;
If da1^.nop <> Nil Then Write(out,',')
End;
Write(out,'] ')
End;
Write(out,' ',basename,hb,'.Sim ',k,Abs(hs):11,' ',
basename,hb,'.Tm');
If diffmeth = '-'
Then Write(out,'l')
Else If diffmeth = '+'
Then Write(out,'h') Else Write(out,'h ',basename,hb,'.Tml');
If absrel In ['o','O'] Then Begin
If ex1^.c In ['R','Z'] Then hs:=ex1^.r Else hs:=mc1^.r;
Write(out,Abs(hs):11)
End;
Writeln(out);
ex1:=ex1^.show
End 
End;
Close(out);
If pr9 = '' Then Begin
ts1:=ts0;
While ts1^.next <> Nil Do Begin
line:=ts1^.tname+' C ? ';ts2:=ts1^.next;
If ts2^.next = Nil Then line:=line+'N' Else line:=line+'F';
Str(percent,line2);
line:=line+' '+absrel+' '+line2+' '+diffmeth+' ';
Str(storeplace,line2);line:=line+line2+' '+basename;
SwapVectors;Exec(zitabase+'\'+'Task.exe',line);
SwapVectors;BigHeap;
ts1:=ts2
End 
End 
End;
Procedure Drawer(a:Byte);
Var st:String[30];
Begin
If a > 0 Then Begin
Str(iter,st);
If figures < 0
Then st:=' ? Iteration '+st+' - Model '+pr3
Else st:=' S Iteration '+st+' - Model '+pr3
End 
Else Begin
If figures < 0
Then st:=' ? Last iteration - Model '+pr3
Else st:=' S Last iteration - Model '+pr3
End;
Writeln(Output,'DRAWER.EXE is working ...');
SwapVectors;Exec(zitabase+'\Drawer.exe',basename+st);SwapVectors;
BigHeap;
i:=0;
Repeat
Inc(i);Str(i,st);st:='00'+st;st:=Copy(st,Length(st)-2,3);
st:=basename+st+'.pcx';FF(st);
Until DosError <> 0;
If (i > dr1) And (figures > 0) Then Begin
Assign(out,zitatemp+'\'+basename+'.dra');Append(out);
For i1:=dr1 To i-1 Do Begin
Str(i1,st);st:='00'+st;st:=Copy(st,Length(st)-2,3);
st:=basename+st+'.pcx';Writeln(out,st)
End;
Close(out);
dr1:=i
End 
End;
Procedure Iteration;
Procedure Place(i,j:Integer;c:Char);
Begin
If (WhereY > 5) And up Then GotoXY(WhereX, WhereY-5);
up:=True;
For k:=1 To 80 Do Write(Output,'');
Str(i,com);lin:='MODEL '+com+';  ITERATION ';
Str(iter,com);lin:=lin+com+'(max. ';
Str(maxi,com);lin:=lin+com+');  ';
Str(j,com);
Case c Of
' ':lin:=lin+'input parameter values are used.';
'+':lin:=lin+'PARAMETER '+com+' is increased by '+line2+'%.';
'-':lin:=lin+'PARAMETER '+com+' is decreased by '+line2+'%.'
End;
i:=Length(lin);
If (i Mod 2) = 1 Then Begin
lin:=lin+' ';Inc(i)
End;
For j:=1 To (80-i) Div 2 Do lin:=' '+lin+' ';
Write(Output,lin);
For j:=1 To 80 Do Write(Output,'')
End;
Procedure Maker(old,new:Extension);
Begin
old:='.'+old;new:='.'+new;
If storeplace = 0
Then lin:=zitasimu Else lin:=zitard;lin:=lin+'\';
FindFirst(lin+'*'+old,AnyFile,di);
If DosError = 0 Then Begin
cu1:=cu0;
While cu1^.next <> Nil Do Begin
FindFirst(lin+cu1^.curve+old,AnyFile,di);
If DosError = 0 Then Begin
If new <> '.any' Then Begin
FindFirst(lin+cu1^.curve+new,AnyFile,di);
If DosError <> 18 Then Begin
Assign(inp,lin+cu1^.curve+new);Erase(inp)
End 
End;
Assign(inp,lin+cu1^.curve+old);
If new = '.any'
Then Erase(inp) Else Rename(inp,lin+cu1^.curve+new)
End;
cu1:=cu1^.next
End 
End 
End;
Begin
Repeat
If pr2[1] In ['a','A'] Then Begin
If iter = 1 Then i1:=0 Else i1:=1;
counter:=-1;FF('J.col');k:=0;
If DosError = 0 Then Begin
time:=di.Time;counter:=0;
pa1:=md1^.parameter;
While pa1^.fit <> '1' Do Begin
Inc(k);
If pa1^.fit = '*' Then Begin
Str(k,line);line:='J'+line+'.col';FF(line);
If i1 = 1 Then Begin
If ((DosError = 0) And (di.Time < time)) Or
(DosError = 18)
Then Begin
time:=di.Time;counter:=k;
If DosError = 18 Then i1:=3
End 
End 
Else
If (i1 = 0) And (DosError = 18) Then Begin
i1:=2;counter:=k
End 
End;
pa1:=pa1^.next
End 
End;
Case counter Of
-1:pr2:='';
0:If iter = 1 Then Str(k+1,pr2)
Else Begin
Str(iter-1,line);FF('Result.'+line);
If di.Time < time Then Str(k+1,pr2) Else pr2:=''
End 
Else Str(counter,pr2)
End 
End;
pa1:=md1^.parameter;counter:=1;
If pr2 = ''  Then Begin
If sopt = ' OPT' Then Begin
Maker('cnc','any');Maker('d','any');Maker('v','any')
End;
Maker('sim','any');Place(md1^.serial,0,' ');
SwapVectors;Exec('Zita.exe',basename+sopt);SwapVectors;BigHeap;
If dosexit <> 0 Then Exit;
Maker('tmp','sim');
SwapVectors;
Exec(zitabase+'\Jc.exe',basename+' '+absrel+' 0');
SwapVectors;BigHeap;
If dosexit <> 0 Then Exit;
Assign(inp,zitatemp+'\J.col');Reset(inp);
Readln(inp,line);
While Pos('Fitting',line) = 0 Do Readln(inp,line);
Writeln(Output);
k:=Pos('=',line)+1;
While line[k] = ' ' Do Inc(k);Delete(line,1,k-1);
k:=2;
While line[k] <> ' ' Do Inc(k);
Val(Copy(line,1,k-1),i2,i1);
If i1 = 0 Then Writeln(Output,
'***  ',i2,' is the Number of Measured Data.');
k:=Pos('=',line);If line[1] = ' ' Then Inc(k);
Delete(line,1,k);Val(line,t,k);
If (k = 0) And (i1 = 0) Then
Writeln(Output,'*** ',t*Sqrt(i2/(i2-md1^.fnum)),
' is the Unweighted Standard Deviation of Data now.');
If WhereY > 5 Then GotoXY(WhereX,WHereY-5);
Close(inp)
End 
Else Begin
Val(pr2,i1,k);
If k = 0 Then
While counter < i1 Do Begin
Inc(counter);pa1:=pa1^.next
End;
If (k <> 0) Or (Not(pa1^.fit In [' ','*','1'])) Then
Errors('The second DOS-parameter cannot be interpreted!');
If (pa1^.fit <> '1') Or (figures <> 0) Then Begin
If storeplace = 0
Then lin:=zitasimu Else lin:=zitard;lin:=lin+'\';
cu1:=cu0;DosError:=0;
While (cu1^.next <> Nil) And (DosError = 0) Do Begin
FindFirst(lin+cu1^.curve+'.sim',AnyFile,di);cu1:=cu1^.next
End;
If DosError <> 0 Then Begin
If sopt = ' OPT' Then Begin
Maker('cnc','any');Maker('d','any');Maker('v','any')
End;
Maker('sim','any');Place(md1^.serial,0,' ');
SwapVectors;Exec('Zita.exe',basename+sopt);
SwapVectors;BigHeap;
If dosexit <> 0 Then Exit;
Maker('tmp','sim')
End 
End 
End;
pr2:='';
While pa1^.fit <> '1' Do Begin
If pa1^.fit = '*' Then Begin
Maker('tmh','any');Maker('tml','any');
Str(counter,line);
If diffmeth In ['+','p','P'] Then Begin
Place(md1^.serial,counter,'+');
SwapVectors;
Exec('Zita.exe',basename+' '+line+' '+line2+' +'+sopt);
SwapVectors;BigHeap;
If dosexit <> 0 Then Exit;
Maker('tmp','tmh')
End;
If diffmeth In ['-','p','P'] Then Begin
Place(md1^.serial,counter,'-');
SwapVectors;
Exec('Zita.exe',basename+' '+line+' '+line2+' -'+sopt);
SwapVectors;BigHeap;
If dosexit <> 0 Then Exit;
Maker('tmp','tml')
End;
SwapVectors;
Exec(zitabase+'\Jc.exe',
basename+' '+absrel+' '+line+' '+diffmeth+' '+line2);
SwapVectors;BigHeap;
If WhereY > 2 Then GotoXY(WhereX, WhereY-2);
If dosexit <> 0 Then Exit;
Maker('tmh','any');Maker('tml','any')
End;
pa1:=pa1^.next;Inc(counter)
End;
While pa1^.fit <> '5' Do pa1:=pa1^.next;
ic1:=pa1^.next;
If sopt = ' OPT' Then Begin
Maker('cnc','any');Maker('d','any');Maker('v','any')
End;
FF('Odes.pas');
GotoXY(WhereX,WhereY+3);Writeln;Writeln;
SwapVectors;Exec(zitabase+'\Gnm.exe','*');
SwapVectors;BigHeap;
If dosexit <> 0 Then Exit;
For k:=1 To 7 Do Writeln;
FF('Res1');
If DosError = 18 Then Begin
If figures <> 0 Then Drawer(0);
Exit
End 
Else Begin
If (figures <> 0) And (figures <= ic1^.actual) Then
If ((iter Mod Abs(figures)) = 0) Or (iter = 1) Then Begin
Drawer(1);If dosexit = 255 Then Exit
End 
End;
Inc(iter);
Assign(inp,zitatemp+'\Res1');Reset(inp);
Assign(out,zitatemp+'\Paramtrs.dat');Rewrite(out);
k:=0;Read(inp,c);
While (Not Eof(inp)) And (k <= di.Size) Do Begin
Inc(k);Write(out,c);Read(inp,c)
End;
Write(out,c);Close(out);Close(inp);
FF('Res1')
Until (DosError <> 0) Or (dosexit <> 0)
End;
Begin
HeapError:=@HeapFunc;
If ParamCount < 9 Then Writeln(Output,'ZITA Version 5.0, 1989-1998',
', written by G. Peintler, JATE (HUNGARY)');
Initialization;
DatJcd;
If (pr2[1] In ['c','C']) Or (pr9 <> '') Then Begin
If pr9 = '' Then Begin
md1:=md0;md2:=md1;
While ((md2^.next <> Nil) Or (md1^.serial = 1)) Do Begin
Str(md1^.serial,pr3);
Assign(out,zitatemp+'\param'+pr3+'.dat');Rewrite(out);
i:=1;pa1:=md1^.parameter;
While pa1^.fit <> '1' Do Begin
Writeln(out,pa1^.value:26,' '+pa1^.fit+' p',i);
pa1:=pa1^.next;Inc(i)
End;
Writeln(out);
While pa1^.fit <> '5' Do Begin
Write(out,pa1^.value:26);pa1:=pa1^.next;
If pa1^.fit = '3' Then Writeln(out)
End;
Writeln(out,pa1^.value:26);
ic1:=pa1^.next;
Writeln(out,ic1^.actual);
Close(out);
md2:=md1;md1:=md1^.next
End 
End 
End 
Else Begin
For i:=1 To 7 Do Writeln;
Assign(inp,zitatemp+'\'+basename+'.jcd');Reset(inp);Readln(inp);
New(cu0);cu0^.next:=Nil;cu0^.curve:='';cu1:=cu0;
While Not SeekEof(inp) Do Begin
Readln(inp,line2);
New(cu2);cu2^.next:=Nil;
cu1^.curve:=Copy(line2,1,Pos('.',line2)-1);cu1^.next:=cu2;cu1:=cu2
End;
Close(inp);
If (pr2[1] In ['e','E']) And (pr3 <> '') Then pr2:=pr3;
md1:=md0;md2:=md1;
If figures <> 0 Then Begin
i:=0;
Repeat
Inc(i);Str(i,line2);line2:='00'+line2;
line2:=basename+Copy(line2,Length(line2)-2,3)+'.pcx';
FF(line2);
Until DosError <> 0;
dr1:=i;
If figures > 0 Then Begin
FF('Model1.res');
If DosError = 18 Then Begin
FF('Result.*');
If DosError = 18 Then Begin
Assign(out,zitatemp+'\'+basename+'.dra');
Rewrite(out);Close(out)
End 
End 
End 
End;
Str(percent:10:3,line2);
While line2[1] <= ' ' Do Delete(line2,1,1);
While ((md2^.next <> Nil) Or (md1^.serial = 1)) And
(dosexit <> 255)  Do Begin
Str(md1^.serial,pr3);FF('Model'+pr3+'.res');
If DosError = 18 Then Begin
iter:=1;FF('Result.1');
While DosError = 0 Do Begin
Inc(iter);Str(iter,lin);FF('Result.'+lin)
End;
FF('Result.1');
If DosError = 18 Then Begin
Assign(out,zitatemp+'\Paramtrs.dat');Rewrite(out);
i:=1;pa1:=md1^.parameter;
While pa1^.fit <> '1' Do Begin
Writeln(out,pa1^.value:26,' '+pa1^.fit+' p',i);
pa1:=pa1^.next;Inc(i)
End;
Writeln(out);
While pa1^.fit <> '5' Do Begin
Write(out,pa1^.value:26);pa1:=pa1^.next;
If pa1^.fit = '3' Then Writeln(out)
End;
Writeln(out,pa1^.value:26);
ic1:=pa1^.next;
Writeln(out,ic1^.actual);
Close(out)
End;
FF('Paramtrs.dat');
If DosError = 0 Then Begin
Assign(inp,zitatemp+'\Paramtrs.dat');Reset(inp);
While Not SeekEof(inp) Do Readln(inp,lin);Close(inp);
While lin[1] < '0' Do Delete(lin,1,1);
i:=1;
While (lin[i] In ['0'..'9']) And (i <= Length(lin)) Do Inc(i);
Delete(lin,i+1,255);
Val(lin,maxi,k);
End 
Else maxi:=ic1^.actual;
Iteration;
If dosexit <> 255 Then Begin
FF('Result.1');
If DosError = 18 Then Begin
Assign(out,zitatemp+'\Result.1');Rewrite(out);
If md1^.fnum > 0
Then Writeln(out,
'An error has occured during the first iteration!')
Else Writeln(out,'There is no any parameter to be fitted!');
Close(out)
End;
Assign(out,zitatemp+'\Model'+pr3+'.res');Rewrite(out);
If ic1^.show <> Nil Then Begin;
title:=ic1^.show;Writeln(out,title^);Writeln(out)
End;
ActDateTime;
Case absrel Of
'a','A':Write(out,'Absolute');
'r','R':Write(out,'Relative');
'o','O':Write(out,'Orthogonal')
End;
Writeln(out,' residuals were used.');
Write(out,'Modifying percent:',percent:12,'. ');
Writeln(out,'Differentation method: ',diffmeth,'.');
Writeln(out);
i1:=1;Str(i1,line);FF('Result.'+line);
While DosError = 0 Do Begin
Assign(inp,zitatemp+'\Result.'+line);Reset(inp);
k:=0;Read(inp,c);
While (Not Eof(inp)) And (k <= di.Size) Do Begin
Inc(k);Write(out,c);Read(inp,c)
End;
Write(out,c);Close(inp);
Inc(i1);Str(i1,line);FF('Result.'+line)
End;
FF('Paramtrs.dat');
If DosError = 0 Then Begin
Writeln(out);
Writeln(out,'******** The last PARAMTRS.DAT file:');
Writeln(out);
Assign(inp,zitatemp+'\Paramtrs.dat');Reset(inp);
While Not Eof(inp) Do Begin
Read(inp,c);Write(out,c)
End;
Close(inp)
End;
FF('J.col');
If (DosError = 0) And
(Pos('n',ParamStr(2)) = 0) And (Pos('N',ParamStr(2)) = 0)
Then Begin
Writeln(out);
Writeln(out,
'******** Unweighted Standard Deviation of Data:');
Assign(inp,'J.col');Rename(inp,'J0.col');
Residuals('a');Residuals('r');Residuals('o')
End;
FF('J0.col');
If DosError = 0 Then Begin
FF('J.col');
If DosError = 0 Then Begin
Assign(inp,'J.col');Erase(inp)
End;
Assign(inp,'J0.col');Rename(inp,'J.col')
End;
FF('J.col');
If DosError = 0 Then Begin
Writeln(out);
Writeln(out,'******** Some pieces of important ',
'information from J*.COL file(s):');
Writeln(out);
Writeln(out,'No.curve Point(s)   Fitting');Writeln(out);
Assign(inp,zitatemp+'\J.col');Reset(inp);
Repeat
Readln(inp,line);
If (Pos('    ',line) <> 0) And (Pos('Number of',line) = 0)
Then Begin
While line[Length(line)] = ' ' Do
Delete(line,Length(line),1);
i1:=Length(line);
While line[i1] > ' ' Do i1:=i1-1;
While line[i1] <= ' ' Do Begin
Delete(line,i1,1);i1:=i1-1
End;
While line[i1] > ' ' Do Begin
Delete(line,i1,1);i1:=i1-1
End;
Writeln(out,line)
End 
Until Eof(inp);
Close(inp)
End;
Writeln(out);FF('J*.col');
While DosError = 0 Do Begin
Assign(inp,zitatemp+'\'+di.Name);
If di.Name <> 'J.COL' Then Begin
Reset(inp);i2:=0;
If Not SeekEof(inp) Then
Repeat
Readln(inp,hr);If hr = 0.0 Then Inc(i2)
Until SeekEof(inp);
Close(inp);
Write(out,i2,' difference quotient');
If i2 < 2
Then Write(out,' equals') Else Write(out,'s equal');
Writeln(out,' to zero in ',di.Name,' file.')
End;
If cols = 0
Then Erase(inp)
Else Begin
line:=di.name;Delete(line,Pos('.',line),1);
line:=zitatemp+'\'+line+'m.'+pr3;
Assign(tem,line);
{$I-}
Reset(tem);
If IOResult = 0 Then Begin
Close(tem);Erase(tem)
End;
{$I+}
Rename(inp,line)
End;
FindNext(di)
End;
Close(out);
FF('Res?');
While DosError = 0 Do Begin
Assign(inp,zitatemp+'\'+di.Name);Erase(inp);FindNext(di)
End;
FF('Result.*');
While DosError = 0 Do Begin
Assign(inp,zitatemp+'\'+di.Name);Erase(inp);FindNext(di)
End;
FF('Paramtrs.dat');
If DosError = 0 Then Begin
Assign(inp,zitatemp+'\Paramtrs.dat');Erase(inp)
End 
End 
End 
Else Writeln(Output,'Model'+pr3+'.res file exists.');
md2:=md1;
If md2^.next <> Nil
Then md1:=md1^.next
Else Begin
New(md1);md1^.serial:=0
End 
End;
Assign(inp,zitatemp+'\'+basename+'.dat');Erase(inp);
Assign(inp,zitatemp+'\'+basename+'.jcd');Erase(inp);
Str(md2^.serial,line);
If line = '1'
Then line:='Model '+line+' has been finished.'
Else line:='Models 1-'+line+' have been finished.';
i:=Length(line);
If (i Mod 2) = 1 Then Begin
line:=line+' ';Inc(i)
End;
For j:=1 To (72-i) Div 2 Do line:=' '+line+' ';
For j:=1 To 80 Do Write(Output,'');
Writeln(Output,line);
For j:=1 To 80 Do Write(Output,'');
If dosexit = 255 Then Halt(255)
End 
End.
End.
