Unit Zita4all;  (* Install environment of using of error handling unit:
Program ...
Uses Zita4all; ...
Begin
ExitSave:=ExitProc;
ExitProc:=@Error_Handling;
ProgramName:=' ... ';
Messages[1]:='';Messages[2]:='';
Messages[3]:='';Messages[4]:=''; ...
End. *)
{$A+,B-,D+,S+,V+,I+}
{$IFDEF CPU87}
{$IFDEF R} {$N-,E-} {$ELSE} {$N+,E-} {$ENDIF}
{$ELSE}
{$IFDEF R} {$N-,E-} {$ELSE} {$N+,E+} {$ENDIF}
{$ENDIF}
Interface
Uses Dos;
Const {$IFDEF S} ac=16; {$ENDIF}
{$IFDEF R} ac=17; {$ENDIF}
{$IFDEF D} ac=24; {$ENDIF}
{$IFNDEF R}{$IFNDEF S}{$IFNDEF D} ac=26; {$ENDIF}{$ENDIF}{$ENDIF}
{$IFNDEF R}
Type {$IFDEF S} Real=Single; {$ENDIF}
{$IFDEF D} Real=Double; {$ENDIF}
{$IFNDEF S}
{$IFNDEF D} Real=Extended; {$ENDIF} {$ENDIF} {$ENDIF}
Var ZitaTemp,ZitaExpr,ZitaSimu,ZitaRd:PathStr;
ProgramName:NameStr;
Messages:Array[1..4] Of String[80];
ExitSave:Pointer;
no:Boolean;
w,less:Integer;
Procedure Is_not_it(place:String;Var txt:Text);
Procedure Error_Handling;
Procedure Environment;
Function Swr(a:Real;cor,less:Integer):PathStr;
Function NeedCalc(sno:String; np:Integer):Boolean;
Implementation
Procedure Is_not_it;
Begin
{$I-}
Reset(txt);
If IOResult <> 0 Then Begin
Messages[1]:=place+' file does not exist!';
Writeln(Output,Messages[1]);Halt(64)
End 
{$I+}
End;
Procedure Error_Handling;
Var                                    i:Byte;
hp,year,month,day,hour,minute,second:Word;
chn:Text;
dirinfo:SearchRec;
Procedure Hex;
Const figure:String[16] = '0123456789ABCDEF';
Var      i:Byte;
hexnum:String[4];
Begin
hexnum:='';
For i:=1 To 4 Do Begin
hexnum:=figure[(hp Mod 16)+1]+hexnum;hp:=hp Div 16
End;
Write(chn,hexnum)
End;
Begin
If ProgramName <> 'DRAWER' Then ExitProc:=ExitSave;
If ExitCode = 0 Then Halt;
If ExitCode = 255 Then Halt(255);
If (ProgramName <> 'DRAWER') Or
((GetEnv('ZitaTEMP') <> '') And (GetEnv('ZitaBASE') <> ''))
Then Begin
Assign(chn,'errors');FindFirst('errors',AnyFile,dirinfo);
If DosError = 18 Then Rewrite(chn) Else Append(chn);
GetDate(year,month,day,hp);GetTime(hour,minute,second,hp);
Write(chn,'Date: ');
If day < 10 Then Write(chn,'0',day:1) Else Write(chn,day:2);
If month < 10
Then Write(chn,'.0',month:1) Else Write(chn,'.',month:2);
hp:=year Mod 100;
If hp < 10 Then Write(chn,'.0',hp:1) Else Write(chn,'.',hp:2);
Write(chn,'. Time: ');
If hour < 10 Then Write(chn,'0',hour:1) Else Write(chn,hour:2);
If minute < 10
Then Write(chn,'h 0',minute:1) Else Write(chn,'h ',minute:2);
If second < 10
Then Write(chn,'m 0',second:1) Else Write(chn,'m ',second:2);
Write(chn,'s ');
If (ErrorAddr = Nil) And (ExitCode < 100)
Then Begin
Writeln(chn,'Handled error ',ExitCode:2,' in ',ProgramName,
'. Message:');
For i:=1 To 4 Do
If Messages[i] <> '' Then Writeln(chn,' ',Messages[i]);
Close(chn);Halt(13)
End 
Else Begin
Write(chn,'Runtime error ');
Case ExitCode Of
100..255:Write(chn,ExitCode:3);
10..99:Write(chn,'0',ExitCode:2);
1..9:Write(chn,'00',ExitCode:1)
End;
If ErrorAddr <> Nil Then Begin
Write(chn,' at ');
hp:=Seg(ErrorAddr^);Hex;Write(chn,':');hp:=Ofs(ErrorAddr^);Hex
End;
Writeln(chn,' in ',ProgramName,':');Write(chn,' ');
Case ExitCode Of
2:Writeln(chn,'File not found.');
3:Writeln(chn,'Path not found.');
4:Writeln(chn,'Too many open files ( more than 15).');
5:Writeln(chn,'File access denied.');
6:Writeln(chn,'Invalid file handle.');
12:Writeln(chn,'Invalid file access code.');
15:Writeln(chn,'Invalid drive number.');
16:Writeln(chn,'Cannot remove current directory.');
17:Writeln(chn,'Cannot rename across drives.');
100:Writeln(chn,'Disk read error.');
101:Writeln(chn,'Disk write error.');
102:Writeln(chn,'File not assigned.');
103:Writeln(chn,'File not open.');
104:Writeln(chn,'File not open for input.');
105:Writeln(chn,'File not open for output.');
106:Writeln(chn,'Invalid numeric format.');
150:Writeln(chn,'Disk is write-protected.');
151:Writeln(chn,'Unknown unit.');
152:Writeln(chn,'Drive not ready.');
153:Writeln(chn,'Unknown command.');
154:Writeln(chn,'CRC error in data.');
155:Writeln(chn,'Bad drive request structure length.');
156:Writeln(chn,'Disk seek error.');
157:Writeln(chn,'Unknown media type.');
158:Writeln(chn,'Sector not found.');
159:Writeln(chn,'Printer out of paper.');
160:Writeln(chn,'Device write fault.');
161:Writeln(chn,'Device read fault.');
162:Writeln(chn,'Hardware failure.');
200:Writeln(chn,'Divison by zero.');
201:Writeln(chn,'Range check error.');
202:Writeln(chn,'Stack overflow error.');
203:Writeln(chn,'Heap overflow error.');
204:Writeln(chn,'Invalid pointer operation.');
205:Writeln(chn,'Floating point overflow.');
206:Writeln(chn,'Floating point underflow.');
207:Writeln(chn,'Invalid floating point operation.')
Else Begin
Writeln(chn,
'I do not know what is the reason for this error!');
Writeln(chn,'   Study a Turbo Pascal or a DOS manual!')
End 
End 
End;
Close(chn)
End 
End;
Procedure Environment;
Type Directories = String[10];
Var       i:Byte;
DirInfo:SearchRec;
Procedure HelpProc(value,base:Directories; haltn:Byte;
Var env:PathStr);
Begin
env:=GetEnv(value);
If env = '' Then env:=base;
FindFirst(env,Directory,DirInfo);
i:=DosError;
If i <> 0 Then FindFirst(env+'\*.*',Directory,DirInfo);
If (i <> 0) And (Not (DosError In [0,18])) Then Begin
Messages[1]:='The DOS environment variable named '''+value
+''' has a wrong value!';
Writeln(Output,Messages[1]);Halt(haltn)
End 
End;
Begin
If (ProgramName = 'ZITA') Or (ProgramName = 'MAKEODE') Then
Writeln(Output,'ZITA Version 5.0, 1989-1998, written by ',
'G. Peintler, JATE (HUNGARY)');
If ProgramName = 'DRAWER'
Then Begin
HelpProc('ZitaTEMP','.',0,ZitaTemp);
HelpProc('ZitaEXPR','.',0,ZitaExpr);
HelpProc('ZitaSIMU','.',0,ZitaSimu);
HelpProc('ZitaRD','.',0,ZitaRd)
End 
Else Begin
HelpProc('ZitaTEMP','.',69,ZitaTemp);
HelpProc('ZitaEXPR','.\Expr',94,ZitaExpr);
HelpProc('ZitaSIMU','.\Simu',71,ZitaSimu);
HelpProc('ZitaRD','.\Simu',70,ZitaRd)
End 
End;
Function Swr;
Var i,j,ac:Integer; h:PathStr; s2:String[2]; s3:String[3];
Begin
Str(a:cor,h);
If less = 2 Then Begin
ac:={$IFDEF S} 16 {$ENDIF}
{$IFDEF R} 17 {$ENDIF}
{$IFDEF D} 24 {$ENDIF}
{$IFNDEF R}
{$IFNDEF S}
{$IFNDEF D} 26 {$ENDIF} {$ENDIF} {$ENDIF}-2;
If cor >= ac Then Begin
i:=Pos('E',h);s2:=Copy(h,i-2,2);s3:=Copy(h,i-5,3);
If ((s3 = '000') Or (s3 = '999')) And (s2 <> '00') Then
Str(a:cor-4,h)
End 
End;
If less > 0 Then Begin
If h[1] = ' ' Then Delete(h,1,1);
cor:=Pos('E',h)+2;
For i:=cor To Length(h)-1 Do If h[cor] = '0' Then Delete(h,cor,1)
End;
If less = 2 Then
If a = 0.0
Then h:='0'
Else Begin
i:=Pos('0E',h);
While i > 0 Do Begin
Delete(h,i,1);i:=Pos('0E',h)
End;
i:=Pos('E+0',h);
If (i = (Length(h)-2)) And (i > 0) Then Delete(h,i,3);
i:=Pos('E-1',h);
If (i = (Length(h)-2)) And (i > 0) Then Begin
Delete(h,i,3);
If h[1] = '-'
Then Begin
Delete(h,3,1);h:='-0.'+Copy(h,2,255)
End 
Else Begin
Delete(h,2,1);h:='0.'+h
End 
End;
i:=Pos('E-2',h);
If (i = (Length(h)-2)) And (i > 0) Then Begin
Delete(h,i,3);
If h[1] = '-'
Then Begin
Delete(h,3,1);h:='-0.0'+Copy(h,2,255)
End 
Else Begin
Delete(h,2,1);h:='0.0'+h
End 
End;
If Copy(h,Length(h)-2,2) = 'E+' Then Begin
Val(h[Length(h)],i,j);
If (j = 0) And (i < (Pos('E',h)-Pos('.',h))) And
(Pos('.',h) > 0) Then Begin
j:=Pos('.',h);
Delete(h,j,1);Delete(h,Length(h)-2,3);
i:=i+j;
h:=Copy(h,1,i-1)+'.'+Copy(h,i,255)
End 
End;
If Pos('.',h) = Length(h) Then Delete(h,Length(h),1)
End;
Swr:=h
End;
Function NeedCalc;
Var j,k,l:Integer; no:Boolean; si:String[20];
Begin
no:=False;
If (sno[1] = '[') And (sno[Length(sno)] = ']') Then Begin
Delete(sno,1,1);Delete(sno,Length(sno),1);
j:=1;
While j <= Length(sno) Do
If sno[j] <= ' ' Then Delete(sno,j,1) Else j:=j+1;
Repeat
j:=Pos(',',sno);
If j > 0
Then Begin
si:=Copy(sno,1,j-1);Delete(sno,1,j)
End 
Else Begin
si:=sno;sno:=''
End;
Val(si,j,l);
If l = 0
Then Begin
If j = np Then no:=True
End 
Else Begin
k:=Pos('..',si);
If k > 0 Then Begin
Val(Copy(si,1,k-1),j,l);
If l = 0 Then Begin
Delete(si,1,k+1);Val(si,k,l);
If l = 0 Then
If (j <= np) And (np <= k) Then no:=True
End 
End 
End 
Until sno = ''
End;
NeedCalc:=no
End;
End.
End.
